# Elastic Enterprise Search

**Old version: [https://drupal.org/project/elastic_appsearch](https://drupal.org/project/elastic_appsearch)**

This module is similar to [Search API Solr](https://www.drupal.org/project/search_api_solr "Search API Solr") What _Search API Solr_ is for Solr, this is for **_[Elastic Enterprise Search](https://www.elastic.co/enterprise-search/)_**.

## Submodules

This module currently have only one submodule called appsearch, that allow drupal to connect with elastic apps search. In future we may add one more submodule to connect with elastic workplace search.

1. Elastic App Search (Added)
1. Elastic Workplace Search (To be added in future)

This module allows Drupal to connect with elastic enterprise search. [Elastic App search](https://www.elastic.co/enterprise-search/ "Elastic App search") is also known as **_Elastic enterprise search_**. Elastic Enterprise search is an elastic product that is built on top of elastic search. Elastic enterprise search provides the capability to add search functionality to any website. This also provides search analytics along with the search. The features of Elastic Enterprise Search are:

1. Top search keywords
2. Top search keywords with no results
3. Top search results with clicks
4. Top search results with no clicks
5. UI to add synonyms
6. Ability to curate search result
7. Pin certain results on top for a specific keyword
8. Ability to adjust the weight on indexed fields
9. Ability to create multiple search engine
10. Fine tune the search results
11. Ability to choose search filters, sorting options and search result title and link

## Dependency

- [Search API](https://www.drupal.org/project/search_api)
- [Elastic Enterprise Search PHP SDK](https://github.com/elastic/enterprise-search-php)
- [Pathauto](https://www.drupal.org/project/pathauto)
- [Guzzle 6 HTTP Adapter](https://github.com/php-http/guzzle6-adapter) (if you are using D9)
- [Guzzle 7 HTTP Adapter](https://github.com/php-http/guzzle7-adapter) (if you are using D10)

This module uses [https://github.com/elastic/enterprise-search-php](https://github.com/elastic/enterprise-search-php) PHP SDK to do all the operations with Elastic Enterprise search.

## Installation

1. Use composer for getting all the module dependencies
1. Enable module
1. Go to Configuration -> Search and metadata -> Elastic AppSearch
1. Add Engine by giving the Appsearch server credentials and enable the server
1. Add Engine by giving the engine details and content types you need to index. Make sure that the machine name should match the engiine name created on Appsearch.
1. Add Schema by selecting the fields you want to index and select the field type.
1. Click on the newly created engine and Click on index now to index all the documents
1. Go to Configuration -> Search and metadata -> Search UI and create a new search UI entity.
1. Now you will have a search block available in block configuration which can be enabled on any page.

## Features

1. Ability to create Multiple Server
2. Ability to create multiple Engines within that server
3. Ability to choose the fields for indexing for each engine
4. Ability to choose the field types for schema
5. Ability to create multiple UI for each search engine
6. Each Search UI is available as a drupal block that can be enabled on any page
7. Ability to choose content types for indexing for each engine
8. Batch indexing of documents

## Limitation

Elastic Enterprise Search provides the ability to index a maximum of 64 fields in each document. There is no option to delete the previously indexed field. You have to delete the complete engine and recreate the new one with the new schema


## UI or App changes

To make any changes to the Search UI App

1. update the elastic_enterprise_search/modules/appsearch/search-ui/src/App.tsx file and rebuild the app.
1. Once the app is built you will need to copy the main.XXXXXXXXX.js file generated to elastic_enterprise_search/modules/appsearch/js directory and rename it to appsearch.js
1. copy the main.XXXXXXXXX.css file generated to elastic_enterprise_search/modules/appsearch/js directory and rename it to appsearch.css
1. Clear cache and verify the FE.

